## mlton 20241230+git20251029+dfsg

=== Makefile ===
## Copyright (C) 2009,2011,2013,2017-2022,2024 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := .
include $(ROOT)/Makefile.config

######################################################################

.PHONY: all
all:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) compiler CHECK_FIXPOINT=false                     # mlton0 -> mlton1
	$(MAKE) script
	$(MAKE) basis
	$(MAKE) libraries
	$(MAKE) tools    CHECK_FIXPOINT=false                     # mlton1 -> tools1
ifeq (2, $(firstword $(sort $(BOOTSTRAP_STYLE) 2)))
	$(MAKE) compiler-clean
	$(MAKE) compiler SELF_COMPILE=true  CHECK_FIXPOINT=false  # tools1 + mlton1 -> mlton2
ifeq (3, $(firstword $(sort $(BOOTSTRAP_STYLE) 3)))
	$(MAKE) tools-clean
	$(MAKE) tools    CHECK_FIXPOINT=true                      # tools1 + mlton2 -> tools2; tools2 == tools1
	$(MAKE) compiler-clean
	$(MAKE) compiler SELF_COMPILE=true  CHECK_FIXPOINT=true   # tools2 + mlton2 -> mlton3; mlton3 == mlton2
endif
endif
	@echo 'Build of MLton succeeded.'

CLEAN_EXCLS := package
$(eval $(MK_COMMON_GOALS))

.PHONY: clean-git
clean-git:
	$(FIND) . -type d -name .git -prune -exec $(RM) '{}' ';'

.PHONY: check
check:
	./bin/regression $(CHECK_ARGS)

######################################################################

.PHONY: basis-no-check
basis-no-check:
	$(RM) "$(LIB)/sml/basis"
	$(MKDIR) "$(LIB)/sml/basis"
	( \
	cd "$(SRC)/basis-library" && \
	$(FIND) . -type f '(' -name '*.mlb' -o -name '*.sml' -o -name '*.sig' -o -name '*.fun' ')' | \
	$(TAR) -c -T - -f - | \
	( cd "$(LIB)/sml/basis" && $(TAR) -x -f - ) \
	)

.PHONY: basis-check
basis-check:
	@echo 'Type checking basis.'
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc '$$(SML_LIB)/basis/libs/all.mlb' >/dev/null

.PHONY: basis
basis:
	$(MAKE) basis-no-check
	$(MAKE) basis-check

.PHONY: compiler
compiler:
	$(MAKE) -C "$(SRC)/mlton"
ifeq (true, $(CHECK_FIXPOINT))
	$(DIFF) -b "$(SRC)/mlton/$(MLTON_OUTPUT)$(EXE)" "$(LIB)/$(MLTON_OUTPUT)$(EXE)"
endif
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT)$(EXE)" "$(LIB)/"

.PHONY: compiler-clean
compiler-clean:
	$(MAKE) -C "$(SRC)/mlton" clean

.PHONY: dirs
dirs:
	$(MKDIR) "$(BIN)" "$(LIB)" "$(INC)"
	$(MKDIR) "$(LIB)/targets/$(TARGET)/include"
	$(MKDIR) "$(LIB)/targets/$(TARGET)/sml"

.PHONY: docs
docs:
	$(MAKE) -C "$(SRC)/doc/guide"

define LIBRARIES_NO_CHECK_TEMPLATE
	$(RM) "$(LIB)/sml/$(1)"
	$(MKDIR) "$(LIB)/sml/$(1)"
	( \
	cd "$(SRC)/lib/$(1)$(2)" && \
	$(FIND) . '!' -path '*/.cm/*' $(3) -type f '(' -name '*.mlb' -o -name '*.sml' -o -name '*.sig' -o -name '*.fun' ')' | \
	$(TAR) -c -T - -f - | \
	( cd "$(LIB)/sml/$(1)" && $(TAR) -x -f - ) \
	)

endef

.PHONY: libraries-no-check
libraries-no-check:
	$(MAKE) -C "$(SRC)/lib/ckit-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,ckit-lib,/ckit/src,)
	$(call LIBRARIES_NO_CHECK_TEMPLATE,cml,,'!' -path '*/tests/*')
	$(MAKE) -C "$(SRC)/lib/mllpt-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mllpt-lib,/ml-lpt/lib,)
	$(MAKE) -C "$(SRC)/lib/mlnlffi-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlnlffi-lib,,)
	$(MAKE) -C "$(SRC)/lib/mlrisc-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlrisc-lib,/MLRISC,'!' -path '*/demo/*' '!' -path '*/Tools/*' '!' -path './autoload.sml' '!' -path './make*.sml')
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlyacc-lib,,)
	$(MAKE) -C "$(SRC)/lib/smlnj-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,smlnj-lib,/smlnj-lib,'!' -path '*/examples/*' '!' -path '*/tests/*' '!' -path '*/Tests/*')

define LIBRARIES_CHECK_TEMPLATE
	@echo "Type checking $(1) library."
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc '$$(SML_LIB)/$(1)/$(1).mlb' >/dev/null
endef

.PHONY: libraries-check
libraries-check:
	$(call LIBRARIES_CHECK_TEMPLATE,ckit-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,cml)
	$(call LIBRARIES_CHECK_TEMPLATE,mllpt-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlnlffi-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlrisc-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlyacc-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,smlnj-lib)

.PHONY: libraries
libraries:
	$(MAKE) libraries-no-check
	$(MAKE) libraries-check

.PHONY: runtime
runtime:
	@echo 'Compiling MLton runtime system for $(TARGET).'
	$(MAKE) -C "$(SRC)/runtime"
	$(CP) "$(SRC)/include/"*.h "$(INC)/"
	$(CP) "$(SRC)/runtime/"*.a "$(LIB)/targets/$(TARGET)/"
	$(CP) "$(SRC)/runtime/gen/constants" "$(LIB)/targets/$(TARGET)/"
	$(CP) "$(SRC)/runtime/gen/c-types.sml" "$(LIB)/targets/$(TARGET)/sml/"
	echo "$(TARGET_OS)" > "$(LIB)/targets/$(TARGET)/os"
	echo "$(TARGET_ARCH)" > "$(LIB)/targets/$(TARGET)/arch"
	$(CP) "$(SRC)/runtime/gen/basis-ffi.sml" \
		basis-library/primitive/basis-ffi.sml
	$(CP) "$(SRC)/runtime/"*.h "$(INC)/"
	$(MV) "$(INC)/c-types.h" "$(LIB)/targets/$(TARGET)/include"
	for d in basis basis/Real basis/Word gc platform util; do	\
		$(MKDIR) "$(INC)/$$d";					\
		$(CP) "$(SRC)/runtime/$$d/"*.h "$(INC)/$$d";		\
	done
	echo "EXE=\"$(EXE)\""                       > "$(LIB)/targets/$(TARGET)/vars"
	echo "CC=\"$(CC)\""                        >> "$(LIB)/targets/$(TARGET)/vars"
	echo "GMP_INC_DIR=\"$(WITH_GMP_INC_DIR)\"" >> "$(LIB)/targets/$(TARGET)/vars"
	echo "GMP_LIB_DIR=\"$(WITH_GMP_LIB_DIR)\"" >> "$(LIB)/targets/$(TARGET)/vars"

.PHONY: install-runtime
install-runtime:
	$(MKDIR) "$(TLIB)/targets/$(TARGET)"
	$(CP) "$(LIB)/targets/$(TARGET)" "$(TLIB)/targets/"

.PHONY: script
script:
	$(SED) \
		-e "s;^LIB_REL_BIN=.*;LIB_REL_BIN=\"$(LIB_REL_BIN)\";" \
		-e 's/mlton-compile/$(MLTON_OUTPUT)/' \
		-e "s;^    SMLNJ=.*;    SMLNJ=\"$(SMLNJ)\";" \
		< "$(SRC)/bin/mlton-script" > "$(BIN)/$(MLTON)"
	$(CHMOD) a+x "$(BIN)/$(MLTON)"
	$(CP) "$(SRC)/bin/static-library" "$(LIB)"
ifeq (mingw, $(TARGET_OS))
	$(CP) "$(SRC)/bin/static-library.bat" "$(LIB)"
endif

ifeq (true, $(CHECK_FIXPOINT))
define TOOLS_TEMPLATE_CHECK_FIXPOINT
	$(DIFF) -b "$(SRC)/$(1)/$(1)$(EXE)" "$(BIN)/$(1)$(EXE)"
endef
else
define TOOLS_TEMPLATE_CHECK_FIXPOINT
endef
endif

define TOOLS_TEMPLATE
	+$(MAKE) -C "$(SRC)/$(1)"
	$(call TOOLS_TEMPLATE_CHECK_FIXPOINT,$(1))
	$(CP) "$(SRC)/$(1)/$(1)$(EXE)" "$(BIN)/"
endef

.PHONY: tools
tools:
	$(call TOOLS_TEMPLATE,mllex)
	$(call TOOLS_TEMPLATE,mlyacc)
	$(call TOOLS_TEMPLATE,mlprof)
	$(call TOOLS_TEMPLATE,mlnlffigen)

.PHONY: tools-clean
tools-clean:
	$(MAKE) -C "$(SRC)/mllex" clean
	$(MAKE) -C "$(SRC)/mlyacc" clean
	$(MAKE) -C "$(SRC)/mlprof" clean
	$(MAKE) -C "$(SRC)/mlnlffigen" clean

######################################################################

# debugged, profiled, traced targets

.PHONY: debugged
debugged:
	$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (debug)" MLTON_OUTPUT=$(MLTON_OUTPUT).debug \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -debug true -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -disable-pass 'deepFlatten'"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).debug$(EXE)" "$(LIB)/"
	$(SED) -e 's/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).debug/' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).debug"
	$(CHMOD) u+x "$(BIN)/$(MLTON).debug"

define PROFILED_TEMPLATE
	+$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (profile-$(1))" MLTON_OUTPUT=$(MLTON_OUTPUT).$(1) \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -profile $(1)"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).$(1)$(EXE)" "$(LIB)/"
	$(SED) -e "s/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).$(1)/" \
		< "$(BIN)/$(MLTON)" \
		>"$(BIN)/$(MLTON).$(1)"
	$(CHMOD) u+x "$(BIN)/$(MLTON).$(1)"
endef

.PHONY: profiled-alloc
profiled-alloc:
	$(call PROFILED_TEMPLATE,alloc)

.PHONY: profiled-count
profiled-count:
	$(call PROFILED_TEMPLATE,count)

.PHONY: profiled-time
profiled-time:
	$(call PROFILED_TEMPLATE,time)

.PHONY: profiled
profiled:
	$(MAKE) profiled-alloc
	$(MAKE) profiled-count
	$(MAKE) profiled-time

.PHONY: traced
traced:
	$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (trace)" MLTON_OUTPUT=$(MLTON_OUTPUT).trace \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -disable-pass 'deepFlatten'"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).trace$(EXE)" "$(LIB)/"
	$(SED) -e 's/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).trace/' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).trace"
	$(CHMOD) u+x "$(BIN)/$(MLTON).trace"

######################################################################

# smlnj targets

SMLNJ := sml

.PHONY: bootstrap-smlnj
bootstrap-smlnj:
	$(MAKE) smlnj-mlton
	$(RM) "$(BIN)/$(MLTON)"
	$(MAKE) OLD_MLTON="$(BIN)/$(MLTON).smlnj" all
	$(RM) "$(LIB)/$(MLTON_OUTPUT_SMLNJ_HEAP)"
	$(RM) "$(BIN)/$(MLTON).smlnj"

.PHONY: smlnj-mlton
smlnj-mlton:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) -C "$(SRC)/mlton" smlnj-mlton
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT_SMLNJ_HEAP)" "$(LIB)/"
	$(MAKE) script
	$(MAKE) basis-no-check
	$(MAKE) libraries-no-check
	$(SED) \
		-e 's;\(doit.* "$$@"\);# \1;' \
		-e 's;# \(doitSMLNJ "$$@"\);\1;' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).smlnj"
	$(CHMOD) u+x "$(BIN)/$(MLTON).smlnj"
	@echo 'Build of MLton (with SML/NJ) succeeded.'

.PHONY: smlnj-mlton-x2
smlnj-mlton-x2:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=2 smlnj-mlton

.PHONY: smlnj-mlton-x4
smlnj-mlton-x4:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=4 smlnj-mlton

.PHONY: smlnj-mlton-x8
smlnj-mlton-x8:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=8 smlnj-mlton

.PHONY: smlnj-mlton-x16
smlnj-mlton-x16:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=16 smlnj-mlton

######################################################################

# polyml targets

.PHONY: bootstrap-polyml
bootstrap-polyml:
	$(MAKE) polyml-mlton
	$(RM) "$(BIN)/$(MLTON)"
	$(MAKE) OLD_MLTON="$(BIN)/$(MLTON).polyml" all
	$(RM) "$(LIB)/$(MLTON_OUTPUT)-polyml$(EXE)"
	$(RM) "$(BIN)/$(MLTON).polyml"

.PHONY: polyml-mlton
polyml-mlton:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) -C "$(SRC)/mlton" polyml-mlton
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT)-polyml$(EXE)" "$(LIB)/"
	$(MAKE) script
	$(MAKE) basis-no-check
	$(MAKE) libraries-no-check
	$(SED) \
		-e 's;\(doit.* "$$@"\);# \1;' \
		-e 's;# \(doitPolyML "$$@"\);\1;' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).polyml"
	$(CHMOD) u+x "$(BIN)/$(MLTON).polyml"
	@echo 'Build of MLton (with Poly/ML) succeeded.'

######################################################################

# mlkit targets

.PHONY: bootstrap-mlkit
bootstrap-mlkit:
	$(MAKE) mlkit-mlton
	$(RM) "$(BIN)/$(MLTON)"
	$(MAKE) OLD_MLTON="$(BIN)/$(MLTON).mlkit" all
	$(RM) "$(LIB)/$(MLTON_OUTPUT)-mlkit$(EXE)"
	$(RM) "$(BIN)/$(MLTON).mlkit"

.PHONY: mlkit-mlton
mlkit-mlton:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) -C "$(SRC)/mlton" mlkit-mlton
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT)-mlkit$(EXE)" "$(LIB)/"
	$(MAKE) script
	$(MAKE) basis-no-check
	$(MAKE) libraries-no-check
	$(SED) \
		-e 's;\(doit.* "$$@"\);# \1;' \
		-e 's;# \(doitMLKit "$$@"\);\1;' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).mlkit"
	$(CHMOD) u+x "$(BIN)/$(MLTON).mlkit"
	@echo 'Build of MLton (with MLKit) succeeded.'

######################################################################

# version target

.PHONY: version
version:
	@echo 'Instantiating version numbers.'
	$(SED) \
		-e "s/^MLTON_VERSION := .*/MLTON_VERSION := $(MLTON_VERSION)/" \
		-e "s/^RELEASE := .*/RELEASE := true/" \
		< "$(SRC)/Makefile.config" \
		> z && \
		$(MV) z "$(SRC)/Makefile.config";

######################################################################

# install and release targets

prefix := $(PREFIX)
exec_prefix := $(prefix)
bindir := $(exec_prefix)/bin
datarootdir := $(prefix)/share
docdir := $(datarootdir)/doc/mlton
libdir := $(exec_prefix)/lib
mandir := $(datarootdir)/man
man1dir := $(mandir)/man1

TBIN := $(DESTDIR)$(bindir)
TLIB := $(DESTDIR)$(libdir)/mlton
TMAN := $(DESTDIR)$(man1dir)
TDOC := $(DESTDIR)$(docdir)
TEXM := $(TDOC)/examples

TLIB_REL_TBIN := $(shell $(call TGT_REL_SRC,$(TLIB),$(TBIN)))

GZIP_MAN := true
ifeq ($(findstring $(TARGET_OS), openbsd solaris), $(TARGET_OS))
GZIP_MAN := false
endif

.PHONY: install
install: install-no-strip install-strip

MAN_PAGES := mlton.1
MAN_PAGES := $(MAN_PAGES) \
	mllex.1 \

=== basis-library/Makefile ===
## Copyright (C) 2010,2013,2016-2017,2019,2022 Matthew Fluet.
 # Copyright (C) 1999-2006, 2008 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

all:

$(eval $(MK_COMMON_GOALS))


RESOLVE_SCOPES = program topdec strdec dec
OBJPTR_MAPS = objptr-rep32.map objptr-rep64.map
NORMAL_METADATA_MAPS = normal-metadata-size32.map normal-metadata-size64.map normal-metadata-size128.map
SEQUENCE_METADATA_MAPS = sequence-metadata-size96.map sequence-metadata-size128.map sequence-metadata-size196.map sequence-metadata-size256.map
SEQINDEX_MAPS = seqindex-int32.map seqindex-int64.map 
DEFAULT_CHAR = char8
DEFAULT_INT = int32 int64 intinf
DEFAULT_REAL = real32 real64
DEFAULT_WORD = word32 word64

.PHONY: def-use
def-use:
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-prefer-abs-paths true -show-def-use basis-library.def-use \
		libs/all.mlb

.PHONY: type-check-def
type-check-def:
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		libs/all.mlb

.PHONY: type-check-all
type-check-all:
	for resolvescope in $(RESOLVE_SCOPES); do \
	for objptr in $(OBJPTR_MAPS); do \
	for normalmetadata in $(NORMAL_METADATA_MAPS); do \
	for sequencemetadata in $(SEQUENCE_METADATA_MAPS); do \
	for seqindex in $(SEQINDEX_MAPS); do \
	for defchar in $(DEFAULT_CHAR); do \
	for defint in $(DEFAULT_INT); do \
	for defreal in $(DEFAULT_REAL); do \
	for defword in $(DEFAULT_WORD); do \
	echo "Type checking: $$resolvescope  $$objptr $$normalmetadata $$sequencemetadata $$seqindex  $$defchar $$defint $$defreal $$defword"; \
	echo "$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "\"resolveScope $$resolvescope\"" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptr" \
		-mlb-path-map "maps/$$normalmetadata" \
		-mlb-path-map "maps/$$sequencemetadata" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	"$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "resolveScope $$resolvescope" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptr" \
		-mlb-path-map "maps/$$normalmetadata" \
		-mlb-path-map "maps/$$sequencemetadata" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	done; done; done; done; done; done; done; done; done;

=== benchmark/Makefile ===
## Copyright (C) 2013,2019,2021-2022 Matthew Fluet.
 # Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := benchmark

all: 	$(NAME)

RUN_MLTON_COMPILE_XARGS := -default-ann 'sequenceNonUnit warn' -default-ann 'warnUnused true'

$(NAME): $(NAME).mlb $(shell $(MLBDEPS) $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) $(RUN_MLTON_COMPILE_XARGS) -target $(TARGET) $(NAME).mlb

$(eval $(MK_COMMON_GOALS))

BENCH := barnes-hut boyer checksum count-graphs DLXSimulator even-odd fft fib flat-array hamlet imp-for knuth-bendix lexgen life logic mandelbrot matrix-multiply md5 merge mlyacc model-elimination mpuz nucleic output1 peek psdes-random ratio-regions ray raytrace simple smith-normal-form string-concat tailfib tak tensor tsp tyan vector32-concat vector64-concat vector-rev vliw wc-input1 wc-scanStream zebra zern
FPBENCH := barnes-hut fft hamlet mandelbrot matrix-multiply nucleic ray raytrace simple tensor tsp tyan vliw zern

BFLAGS := -mlton "/usr/bin/mlton" -mlton "mlton -optimize-ssa {false,true}"
BFLAGS := -wiki -mlton "/usr/bin/mlton" -mlkit -mosml -poly -smlnj
BFLAGS := -mlton "$(BIN)/mlton"

.PHONY: test
test: $(NAME)
	cd tests && ../benchmark $(BFLAGS) $(BENCH)

QBENCH := $(BENCH)
QBFLAGS := -mlton "~/devel/mlton/builds/20171013.233239-g5513092e3/bin/mlton"
QBFLAGS += -mlton "~/devel/mlton/mlton.git/build/bin/mlton -cse-canon {ascHash,descHash,ascIndex,descIndex}"

.PHONY: qtest
qtest: $(NAME)
	cd tests && ../benchmark $(QBFLAGS) $(QBENCH) && $(MAKE) clean

=== man/Makefile ===
## Copyright (C) 2022 Matthew Fluet
 # Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

all:

.PHONY: ps
ps: mllex.ps mlprof.ps mlton.ps

%.pdf: %.ps
	ps2pdf $<

%.ps: %.1
	man -t ./$< >$@

$(eval $(MK_COMMON_GOALS))

=== mllex/Makefile ===
## Copyright (C) 2009,2013,2018-2022 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mllex

all:	$(NAME)

$(NAME): $(shell $(MLBDEPS) $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

$(eval $(MK_COMMON_GOALS))

PDFLATEX := pdflatex

doc/mllex.pdf:
	$(MAKE) -C doc mllex.pdf

mllex.pdf: doc/mllex.pdf
	$(CP) doc/mllex.pdf mllex.pdf

DOCS :=
ifeq (true, $(call HAVE_CMD,$(PDFLATEX)))
DOCS += mllex.pdf
endif

.PHONY: docs
docs: $(DOCS)


.PHONY: test
test: $(NAME)
	$(CP) ../mlton/front-end/ml.lex .			\
	$(NAME) ml.lex &&					\
	$(DIFF) ml.lex.sml ../mlton/front-end/ml.lex.sml	\
	$(RM) ml.lex ml.lex.sml

=== mlnlffigen/Makefile ===
## Copyright (C) 2018-2022 Matthew Fluet
 # Copyright (C) 2005-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlnlffigen

all:	$(NAME)

$(NAME): $(shell $(MLBDEPS) $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

$(eval $(MK_COMMON_GOALS))

cppcmd.sml : gen-cppcmd
	./gen-cppcmd > $@

=== mlprof/Makefile ===
## Copyright (C) 2009,2018-2022 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlprof

all:	$(NAME)

$(NAME): $(shell $(MLBDEPS) $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

$(eval $(MK_COMMON_GOALS))

=== mlton/Makefile ===
## Copyright (C) 2010,2013,2016,2018-2023 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

RUN_MLTON_RUNTIME_XARGS := ram-slop 0.7
RUN_MLTON_COMPILE_XARGS :=

MLTON_DEBUG := false

ifeq (true, $(SELF_COMPILE))
# Older versions of `mlton` may not support `sequenceNonUnit` or `warnUnused`.
RUN_MLTON_COMPILE_XARGS += -default-ann 'sequenceNonUnit warn'
RUN_MLTON_COMPILE_XARGS += -default-ann 'warnUnused true'
# RUN_MLTON_COMPILE_XARGS += -type-check true
RUN_MLTON_COMPILE_XARGS += -const 'MLton.debug $(MLTON_DEBUG)'
# We're self-compiling, so don't use any stubs.
MLTON_MLB := mlton.mlb
else
# We're bootstrapping, so use stubs.
MLTON_MLB := mlton-stubs.mlb
endif

## When self-compiling the current MLton sources with `Zone` enabled,
## the resulting compiler exhibits a space leak; see MLton/mlton#334
ifeq ($(RUN_MLTON_VERSION), $(firstword $(sort $(RUN_MLTON_VERSION) 20170629)))
RUN_MLTON_COMPILE_XARGS += -drop-pass zone
else ifeq ($(RUN_MLTON_VERSION), $(firstword $(sort $(RUN_MLTON_VERSION) 20191003)))
RUN_MLTON_COMPILE_XARGS += -disable-pass zone
endif

MLTON_FRONT_END_GEN_SOURCES :=		\
	front-end/ml.lex.sml 		\
	front-end/ml.grm.sig 		\
	front-end/ml.grm.sml 		\
	front-end/mlb.lex.sml 		\
	front-end/mlb.grm.sig 		\
	front-end/mlb.grm.sml

MLTON_GEN_SOURCES := 			\
	$(MLTON_FRONT_END_GEN_SOURCES)	\
	control/version.sml

ifneq (,$(or						\
	$(findstring mlton-stubs.mlb,$(MLTON_MLB)),	\
	$(findstring smlnj-mlton,$(MAKECMDGOALS)),	\
	$(findstring polyml-mlton,$(MAKECMDGOALS),	\
	$(findstring mlkit-mlton,$(MAKECMDGOALS)),	\
	)))
MLTON_GEN_SOURCES += 			\
	../lib/stubs/mlton-stubs/pre-mlton.sml
endif

MLTON_SOURCES :=			\
	$(shell $(MLBDEPS) $(MLTON_MLB))\
	$(MLTON_GEN_SOURCES)

.PHONY: all
all: $(MLTON_OUTPUT)

SHOW_VARS += MLTON_MLB

$(eval $(MK_COMMON_GOALS))

######################################################################

$(MLTON_OUTPUT): $(MLTON_SOURCES)
	@echo 'Compiling mlton'
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) gc-summary -- \
		$(RUN_MLTON_COMPILE_XARGS) -verbose 2 $(RUN_MLTON_COMPILE_ARGS)	\
		-target $(TARGET) -output $(MLTON_OUTPUT)			\
		$(MLTON_MLB)

define GEN_TEMPLATE
ifeq ($$(shell ($$(CAT) $$(subst .sml,_sml.src,$(1)) ; echo $$(foreach VAR,$(2),'$$($$(VAR))'); if [ -e $(1) ]; then $$(CAT) $(1); fi) | $$(SHA1DGST)),$$(shell if [ -e $$(subst .sml,_sml.chk,$(1)) ]; then $$(CAT) $$(subst .sml,_sml.chk,$(1)); fi))
$(1): $$(subst .sml,_sml.src,$(1))
	touch $$@
else
$$(shell $$(RM) $(1))
$(1): $$(subst .sml,_sml.src,$(1))
	$$(SED) \
		$$(foreach VAR,$(2),-e "s/$$(VAR)/$$($$(VAR))/") \
		< $$< \
		> $$@
	($$(CAT) $$<; echo $$(foreach VAR,$(2),'$$($$(VAR))'); $$(CAT) $$@) | $$(SHA1DGST) > $$(subst .sml,_sml.chk,$(1))
endif
endef

$(eval $(call GEN_TEMPLATE,control/version.sml,MLTON_NAME MLTON_VERSION))
$(eval $(call GEN_TEMPLATE,../lib/stubs/mlton-stubs/pre-mlton.sml,MLTON_DEBUG HOST_ARCH HOST_OS))

ifeq (true,$(call HAVE_CMD,$(RUN_MLLEX)))
front-end/%.lex.sml: front-end/%.lex
	$(RM) $<.*
	$(RUN_MLLEX) $<
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/val s = List.map f (List.rev (tl (List.rev s)))/val s = Pervasive.List.map f (Pervasive.List.rev (tl (Pervasive.List.rev s)))/' $<.sml.in > $<.sml
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in Vector.fromList(List.map g/in Vector.fromList(Pervasive.List.map g/' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CP) $<.sml $<.sml.boot
	$(CHMOD) a-w $<.*
else
front-end/%.lex.sml: front-end/%.lex.sml.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) a-w $@
endif

ifeq (true,$(call HAVE_CMD,$(RUN_MLYACC)))
front-end/%.grm.sig front-end/%.grm.sml: front-end/%.grm
	$(RM) $<.*
	$(RUN_MLYACC) $<
	$(MV) $<.sig $<.sig.in
	$(SED) -e '' $<.sig.in > $<.sig
	$(RM) $<.sig.in
	$(CP) $<.sig $<.sig.boot
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in f 0 handle General.Subscript => ()/in f 0 handle Pervasive.General.Subscript => ()/' $<.sml.in > $<.sml
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in Array.fromList(List.map actionRowLookUp actionRowNumbers)/in Array.fromList(Pervasive.List.map actionRowLookUp actionRowNumbers)/' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CP) $<.sml $<.sml.boot
	$(CHMOD) a-w $<.*
else
front-end/%.grm.sig: front-end/%.grm.sig.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) a-w $@
front-end/%.grm.sml: front-end/%.grm.sml.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) a-w $@
endif

mlton-stubs.mlb: $(shell $(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)') $(shell $(MLBDEPS) mlton.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)')
	(									\
		echo '$$(SML_LIB)/basis/unsafe.mlb';				\
		echo '$$(SML_LIB)/basis/sml-nj.mlb';				\
		echo '$$(SML_LIB)/basis/mlton.mlb';				\
		echo '$$(SML_LIB)/basis/basis.mlb';				\
		$(MLBDEPS) mlton.mlb |						\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlyacc';					\
		$(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb |		\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlton-stubs';					\
		$(MLBDEPS) mlton.mlb |						\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) -v 'sml/basis' |				\
			$(GREP) -v 'targets' |					\
			$(GREP) -v 'mlyacc';					\
	) > mlton-stubs.mlb

######################################################################

.PHONY: def-use
def-use: mlton.def-use

mlton.def-use: $(MLTON_SOURCES)
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) --	\
		$(RUN_MLTON_COMPILE_XARGS) -verbose 0 $(RUN_MLTON_COMPILE_ARGS)	\
		-stop tc -prefer-abs-paths true -show-def-use mlton.def-use	\
		$(MLTON_MLB)

######################################################################

ifneq (,$(REMOTE_TARGET))
mlton-bootstrap-$(REMOTE_TARGET).tgz: $(MLTON_SOURCES)
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) gc-summary -- \
		$(RUN_MLTON_COMPILE_XARGS) -verbose 2 $(RUN_MLTON_COMPILE_ARGS)	\
		-target $(REMOTE_TARGET) -output $(MLTON_OUTPUT) \
		-codegen c -stop g \
		$(MLTON_MLB)
	$(TAR) czf $@ $(MLTON_OUTPUT).*.c
	$(RM) $(MLTON_OUTPUT).*.c
endif

######################################################################

#
# The following rebuilds the heap file for the SML/NJ compiled version of MLton.
#
ifneq (,$(findstring smlnj-mlton,$(MAKECMDGOALS)))
.PHONY: smlnj-mlton
smlnj-mlton: $(MLTON_OUTPUT_SMLNJ_HEAP)

SMLNJ_VERSION := $(shell "$(SMLNJ)" @SMLversion | $(SED) -n "s/sml \(.*\)/\1/p")
SMLNJ_PATCH_VERSION := $(or $(shell echo $(SMLNJ_VERSION) | $(SED) -n 's/\([0-9][0-9]*\)\.\([0-9][0-9]*\)\.\([0-9][0-9]*\)/\3/p'),0)

SMLNJ_CM_SERVERS_NUM := 0

$(MLTON_OUTPUT_SMLNJ_HEAP):
	(									\
		echo 'local';							\
		echo 'fun loop 0 = () | loop n = (CM.Server.start {cmd = (CommandLine.name (), ["@CMslave"]), name = "server" ^ (Int.toString n), pathtrans = NONE, pref = 0}; loop (n - 1));'; \
		echo 'in';							\
		echo 'val _ = loop $(SMLNJ_CM_SERVERS_NUM);';			\
		echo 'end;';							\
		echo 'if (CM.make "mlton-smlnj.cm") handle _ => false';		\
		echo '   then ()';						\
		echo '   else OS.Process.exit OS.Process.failure;'; 		\
		echo 'SMLofNJ.exportFn("$@",Main.main);'			\
	) | CM_VERBOSE=false CONTROL_POLY_EQ_WARN=false "$(SMLNJ)" -DSMLNJ_PATCH_VERSION=$(SMLNJ_PATCH_VERSION)

$(MLTON_OUTPUT_SMLNJ_HEAP).d: $(shell $(FIND) ../lib/stubs -type f -name '*.cm') $(shell $(FIND) ../lib/mlyacc-lib -type f -name '*.cm') $(shell $(FIND) ../lib/mlton -type f -name '*.cm') $(shell $(FIND) . -type f -name '*.cm') $(MLTON_GEN_SOURCES)
	@$(RM) $@
	@touch $@
	CM_VERBOSE=false $(SMLNJ_MAKEDEPEND) -DSMLNJ_PATCH_VERSION=$(SMLNJ_PATCH_VERSION) -n -f $@ mlton-smlnj.cm $(MLTON_OUTPUT_SMLNJ_HEAP) || ($(RM) $@ ; exit 1)
-include $(MLTON_OUTPUT_SMLNJ_HEAP).d
endif

######################################################################

#
# The following rebuilds the executable file for the Poly/ML compiled version of
# MLton.
#
ifneq (,$(findstring polyml-mlton,$(MAKECMDGOALS)))
.PHONY: polyml-mlton
polyml-mlton: $(MLTON_OUTPUT)-polyml

$(MLTON_OUTPUT)-polyml: mlton-polyml.sml $(shell [ -e mlton-polyml.sml ] && $(CAT) mlton-polyml.sml | $(SED) -n 's/use "\(.*\)";/\1/p') $(MLTON_GEN_SOURCES)
	$(POLYC) -o $@ mlton-polyml.sml

mlton-polyml.sml: ../lib/stubs/polyml/basis/sources.use ../lib/stubs/polyml/mlton/sources.use $(shell $(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)') $(shell $(MLBDEPS) mlton.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)')
	(									\
		$(CAT) ../lib/stubs/polyml/basis/sources.use |			\
			$(SED) 's|use "\(.*\)";|../lib/stubs/polyml/basis/\1|'; \
		$(MLBDEPS) mlton.mlb | $(GREP) -v 'mlb$$' | $(GREP) 'mlyacc'; 	\
		$(CAT) ../lib/stubs/polyml/mlton/sources.use |			\
			$(SED) 's|use "\(.*\)";|../lib/stubs/polyml/mlton/\1|'; \
		$(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb |		\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlton-stubs';					\
		$(MLBDEPS) mlton.mlb |						\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) -v 'sml/basis' |				\
			$(GREP) -v 'targets' |					\
			$(GREP) -v 'mlton-stubs' |				\
			$(GREP) -v 'mlyacc' |					\
			$(GREP) -v 'call-main.sml';				\
	) | $(SED) 's|\(.*\)|use "\1";|' > $@
	echo "val main = Main.mainWrapped;" >> $@
endif

######################################################################

#
# The following rebuilds the executable file for the MLKit compiled version of
# MLton.
#
ifneq (,$(findstring mlkit,$(MAKECMDGOALS)))
.PHONY: mlkit-mlton
mlkit-mlton: $(MLTON_OUTPUT)-mlkit

$(MLTON_OUTPUT)-mlkit: $(shell $(MLBDEPS) mlton-mlkit.mlb | $(GREP) -v '$$(SML_LIB)') $(MLTON_GEN_SOURCES)
	$(MLKIT) $(MLKIT_FLAGS) -o $@ mlton-mlkit.mlb

mlton-mlkit.mlb: ../lib/stubs/mlkit/basis/sources.mlb ../lib/stubs/mlkit/mlton/sources.mlb $(shell $(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)') $(shell $(MLBDEPS) mlton.mlb | $(GREP) 'mlb$$' | $(GREP) -v '$$(SML_LIB)')
	(									\
		echo 'local';							\
		echo '../lib/stubs/mlkit/basis/sources.mlb';			\
		echo '../lib/stubs/mlkit/basis/unsafe.mlb';			\
		$(MLBDEPS) mlton.mlb | $(GREP) -v 'mlb$$' | $(GREP) 'mlyacc'; 	\
		echo '../lib/stubs/mlkit/mlton/sources.mlb';			\
		$(MLBDEPS) ../lib/stubs/mlton-stubs/sources.mlb |		\
			$(GREP) -v 'mlb$$' | 					\
			$(GREP) 'mlton-stubs';					\
		$(MLBDEPS) mlton.mlb |						\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) -v 'sml/basis' | 				\
			$(GREP) -v 'targets' |					\
			$(GREP) -v 'mlton-stubs' |				\
			$(GREP) -v 'mlyacc' |					\
			$(GREP) -v 'call-main.sml';				\
		echo 'in';							\
		echo 'call-main.sml';						\
		echo 'end';							\
	) > $@

# %-mlkit.mlb: %.mlb Makefile
# 	$(RM) $(notdir $*)-mlkit-bind*.sml
# 	bindk=0; \
# 	while IFS= read -r line; do \
# 	    indent="$$(echo "$$line" | $(SED) -E 's/^([ ]*)(.*)[ ]*$$/\1/')"; \
# 	    line="$$(echo "$$line" | $(SED) -E 's/^([ ]*)(.*)[ ]*$$/\2/')"; \
# 	    if echo "$$line" | $(GREP) -q "^\(functor\|signature\|structure\)"; then \
# 	        bind="$$line"; \
# 	        xbind="$$(echo "$$bind" | $(SED) -E 's/^((structure|functor|signature)[ ]+([^ =]+))[ ]*$$/\1 = \3/')"; \
# 	        echo "$$xbind" > $*-mlkit-bind$${bindk}.sml; \
# 	        echo "$${indent}$(notdir $*)-mlkit-bind$${bindk}.sml (* $${bind} *)"; \
# 	        bindk=$$((bindk + 1)); \
# 	    elif echo "$$line" | $(GREP) -q "\.mlb$$"; then \
# 	        case "$$line" in \
# 	          '$$(SML_LIB)/basis/basis.mlb') echo "$${indent}$(SRC)/lib/stubs/mlkit/basis/sources.mlb" ;; \
# 	          '$$(SML_LIB)/basis/mlton.mlb') \
# 	              case "$<" in \
# 	                */mlton-stubs/sources.mlb) \
# 	                    echo "$${indent}$(SRC)/lib/stubs/mlkit/mlton/sources.mlb" ;; \
# 	                *) \
# 	                    echo "$${indent}$(SRC)/lib/stubs/mlton-stubs/sources-mlkit.mlb" ;; \
# 	              esac ;; \

=== mlyacc/Makefile ===
## Copyright (C) 2009,2013,2018-2022 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlyacc

all:	$(NAME)

$(NAME): $(shell $(MLBDEPS) $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

$(eval $(MK_COMMON_GOALS))

ifeq (true,$(call HAVE_CMD,$(RUN_MLLEX)))
src/%.lex.sml: src/%.lex
	$(RM) $<.*
	$(RUN_MLLEX) $<
	$(MV) $<.sml $<.sml.in
	$(SED) -e '' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CP) $<.sml $<.sml.boot
	$(CHMOD) -w $<.*
else
src/%.lex.sml: src/%.lex.sml.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) -w $@
endif

ifeq (true,$(call HAVE_CMD,$(RUN_MLYACC)))
src/%.grm.sig src/%.grm.sml: src/%.grm
	$(RM) $<.*
	$(RUN_MLYACC) $<
	$(MV) $<.sig $<.sig.in
	$(SED) -e '' $<.sig.in > $<.sig
	$(RM) $<.sig.in
	$(CP) $<.sig $<.sig.boot
	$(MV) $<.sml $<.sml.in
	$(SED) -e '' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CP) $<.sml $<.sml.boot
	$(CHMOD) -w $<.*
else
src/%.grm.sig: src/%.grm.sig.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) -w $@
src/%.grm.sml: src/%.grm.sml.boot
	$(RM) $@
	$(CP) $< $@
	$(CHMOD) -w $@
endif


PDFLATEX := pdflatex

doc/mlyacc.pdf:
	$(MAKE) -C doc mlyacc.pdf

mlyacc.pdf: doc/mlyacc.pdf
	$(CP) doc/mlyacc.pdf .

DOCS :=
ifeq (true, $(call HAVE_CMD,$(PDFLATEX)))
DOCS += mlyacc.pdf
endif

.PHONY: docs
docs: $(DOCS)


.PHONY: test
test: $(NAME)
	$(CP) ../mlton/front-end/ml.grm .			\
	$(NAME) ml.grm &&					\
	$(DIFF) ml.grm.sig ../mlton/front-end/ml.grm.sig &&	\
	$(DIFF) ml.grm.sml ../mlton/front-end/ml.grm.sml	\
	$(RM) ml.grm ml.grm.sig ml.grm.sml ml.grm.desc

=== regression/Makefile ===
## Copyright (C) 2022 Matthew Fluet
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

all:

CLEAN_EXES := true
CLEAN_EXTS := c s S
$(eval $(MK_COMMON_GOALS))

.PHONY: abnormal
abnormal:
	ls -1 | egrep -v '\.ok$$|\.sml$$'

=== runtime/Makefile ===
## Copyright (C) 2010-2013,2018,2019-2022,2024 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

ifeq ($(TARGET), self)
CROSS_PREFIX :=
else
CROSS_PREFIX := $(TARGET)-
endif

EXE :=

# Building the runtime for a target platform requires executing target-platform
# executables (eg., `gen/gen-types` to determine the sizes of C types).
# When cross compiling, it may be possible/necessary to emulate/execute the
# target-platform executable on the host platform (e.g., Wasmtime to execute
# WebAssembly programs).
EMULATE :=

MDVARIANTS := OPT DBG
PIVARIANTS := DPI NPI PIC PIE

OPTSUFFIX :=
DBGSUFFIX := -dbg
DPISUFFIX :=
NPISUFFIX := -npi
PICSUFFIX := -pic
PIESUFFIX := -pie

WITH_OPT_RUNTIME := true
WITH_DBG_RUNTIME := true
WITH_DPI_RUNTIME := true
WITH_NPI_RUNTIME := $(or $(findstring true,$(RELEASE) $(WITH_ALL_RUNTIME)),false)
WITH_PIC_RUNTIME := $(or $(findstring true,$(RELEASE) $(WITH_ALL_RUNTIME)),false)
WITH_PIE_RUNTIME := $(or $(findstring true,$(RELEASE) $(WITH_ALL_RUNTIME)),false)

# These flags can be overridden by the user
CCFLAGS :=
MFLAGS :=
CPPFLAGS :=
CFLAGS :=
LDFLAGS :=

XCCFLAGS := -std=gnu11
XMFLAGS :=
XCPPFLAGS :=
XCFLAGS := -fno-common -pedantic -Wall -Wextra
OPTXCFLAGS := -Wdisabled-optimization -O2
DBGXCFLAGS := -g -DASSERT=1 -Wno-uninitialized -O0
DPIXCFLAGS :=
NPIXCFLAGS := -fno-pic -fno-pie
PICXCFLAGS := -fPIC
PIEXCFLAGS := -fPIE
XLDFLAGS :=

ifneq ($(WITH_GMP_INC_DIR),)
XCPPFLAGS += -I$(WITH_GMP_INC_DIR)
endif

ifneq ($(WITH_GMP_LIB_DIR),)
XLDFLAGS += -L$(WITH_GMP_LIB_DIR)
endif

XCPPFLAGS += -I.

# Win32&64 don't use PIC code, all other platforms do
ifeq ($(findstring $(TARGET_OS), mingw cygwin),$(TARGET_OS))
WITH_PIC_RUNTIME := false
WITH_PIE_RUNTIME := false
endif

# Make mlton library symbols private (win32&64 use another technique)
ifeq ($(findstring $(TARGET_OS), mingw cygwin),)
XCFLAGS += -fvisibility=hidden
endif

ifeq ($(TARGET_ARCH), alpha)
XMFLAGS += -mieee -mbwx -mtune=ev6 -mfp-rounding-mode=d
endif

ifeq ($(TARGET_ARCH), amd64)
XMFLAGS += -m64
endif

ifeq ($(TARGET_ARCH), ia64)
XMFLAGS += -mtune=itanium2
ifeq ($(TARGET_OS), hpux)
XMFLAGS += -mlp64
endif
endif

ifeq ($(TARGET_OS)-$(TARGET_ARCH), aix-powerpc64)
XMFLAGS += -maix64
AR := ar -X 64 rc
endif

ifeq ($(TARGET_ARCH), sparc)
XMFLAGS += -m32 -mcpu=v8
XCFLAGS := -Wa,-xarch=v8plusa
endif

ifeq ($(TARGET_ARCH), x86)
XMFLAGS += -m32
endif

ifeq ($(TARGET_OS), cygwin)
EXE := .exe
endif

ifeq ($(TARGET_OS), wasi)
EMULATE := wasmtime
XCPPFLAGS += -D_WASI_EMULATED_SIGNAL \
             -D_WASI_EMULATED_PROCESS_CLOCKS \
             -D_WASI_EMULATED_GETPID
XLDFLAGS += -lwasi-emulated-signal \
            -lwasi-emulated-process-clocks \
            -lwasi-emulated-getpid
endif

ifeq ($(TARGET_OS), mingw)
EXE := .exe
# GCC doesn't recognize the %I64 format specifier which means %ll on windows
XCFLAGS += -Wno-format -Wno-missing-format-attribute
endif

ifeq ($(TARGET_OS), solaris)
XCFLAGS += -funroll-all-loops
endif

### MK_FLAGS ###

## MK_FLAGS (SRC,PHASE[,KS])
define MK_FLAGS
$(strip \
$(XCCFLAGS) $($(1)_XCCFLAGS) $(CCFLAGS) \
$(XMFLAGS) $($(1)_XMFLAGS) $(MFLAGS) \
$(if $(findstring $(2),CPP C),$(CPPFLAGS) $(XCPPFLAGS) $($(1)_XCPPFLAGS)) \
$(if $(findstring $(2),C), \
$(CFLAGS) \
$(XCFLAGS) \
$(foreach K,$(3),$($(K)XCFLAGS)) \
$($(1)_XCFLAGS) \
$(foreach K,$(3),$($(1)_$(K)XCFLAGS))) \
$(if $(findstring $(2),LD),$(LDFLAGS) $(XLDFLAGS) $($(1)_XLDFLAGS)) \
)
endef

### Position-independent (or not) ###

ifeq ($(shell echo "__pie__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C,PIE) -P -E -),2)
HAVE_PIE := true
ifeq ($(shell echo "__pie__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C) -P -E -),2)
WITH_DEFAULT_PIE := true
else
WITH_DEFAULT_PIE := false
endif
else
HAVE_PIE := false
WITH_PIE_RUNTIME := false
WITH_DEFAULT_PIE := false
endif

ifeq ($(shell echo "__pic__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C,PIC) -P -E -),2)
HAVE_PIC := true
ifeq ($(WITH_DEFAULT_PIE),true)
WITH_DEFAULT_PIC := false
else ifeq ($(shell echo "__pic__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C) -P -E -),2)
WITH_DEFAULT_PIC := true
else
WITH_DEFAULT_PIC := false
endif
else
HAVE_PIC := false
WITH_PIC_RUNTIME := false
WITH_DEFAULT_PIC := false
endif

ifeq ($(shell echo "__pic__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C,NPI) -P -E -),__pic__)
HAVE_NPI := true
ifeq ($(shell echo "__pic__" | $(CROSS_PREFIX)$(CC) $(call MK_FLAGS,-,C) -P -E -),__pic__)
WITH_DEFAULT_NPI := true
else
WITH_DEFAULT_NPI := false
endif
else
HAVE_NPI := false
WITH_NPI_RUNTIME := false
WITH_DEFAULT_NPI := false
endif

### pattern rules ###

%.d: %.c
	$(CROSS_PREFIX)$(CC) $(call MK_FLAGS,$<,CPP) -MM -MG $(foreach MD,$(MDVARIANTS),$(foreach PI,$(PIVARIANTS),-MT $(subst .d,$($(MD)SUFFIX)$($(PI)SUFFIX).o,$@))) -MT $@ -MM -MG -MF $@ $<

## O_C_TEMPLATE (MD,PI)
define O_C_TEMPLATE
%$($(1)SUFFIX)$($(2)SUFFIX).o: %.c
	$$(CROSS_PREFIX)$$(CC) $$(call MK_FLAGS,$$<,C,$(1) $(2)) -c -o $$@ $$<
endef

$(foreach MD,$(MDVARIANTS),$(foreach PI,$(PIVARIANTS), \
$(eval $(call O_C_TEMPLATE,$(MD),$(PI)))))

%$(EXE): %.o
	$(CROSS_PREFIX)$(CC) $(call MK_FLAGS,$<,LD) -o $@ $^

%.a:
	$(RM) $@
	$(CROSS_PREFIX)$(AR) rc $@ $^
	$(CROSS_PREFIX)$(RANLIB) $@

define A_TEMPLATE
$(foreach MD,$(MDVARIANTS),$(foreach PI,$(PIVARIANTS), \
ifeq ($(and $(findstring DPI,$(PI)),$(findstring true,$(foreach PIX,$(PIVARIANTS),$(WITH_DEFAULT_$(PIX))))),true)
$(foreach PIX,$(PIVARIANTS), \
ifeq ($(WITH_DEFAULT_$(PIX)),true)
lib$(1)$($(MD)SUFFIX).a: lib$(1)$($(MD)SUFFIX)$($(PIX)SUFFIX).a
	$$(CP) $$< $$@
endif
)
else
lib$(1)$($(MD)SUFFIX)$($(PI)SUFFIX).a: $(patsubst %.o,%$($(MD)SUFFIX)$($(PI)SUFFIX).o,$($(2)_OBJS))
endif
))
endef

### all ###

LIBS := \
$(foreach MD,$(MDVARIANTS), \
$(if $(findstring true,$(WITH_$(MD)_RUNTIME)),\
$(foreach PI,$(PIVARIANTS), \
$(if $(findstring true,$(WITH_$(PI)_RUNTIME)),\
$(patsubst %.a,%$($(MD)SUFFIX)$($(PI)SUFFIX).a,libgdtoa.a libmlton.a)))))
ALL += $(LIBS) gen/constants gen/c-types.sml gen/basis-ffi.sml

.PHONY: all
all: $(ALL)

### c-types.h  ml-types.h  gen/c-types.sml ###

c-types.h: gen/c-types.h
	$(CP) $< $@
ml-types.h: gen/ml-types.h
	$(CP) $< $@

gen/ml-types.h: gen/gen-types$(EXE)
	$(EMULATE) ./gen/gen-types$(EXE) ml-types.h > gen/ml-types.h
gen/c-types.h: gen/gen-types$(EXE)
	$(EMULATE) ./gen/gen-types$(EXE) c-types.h > gen/c-types.h
gen/c-types.sml: gen/gen-types$(EXE)
	$(EMULATE) ./gen/gen-types$(EXE) c-types.sml > gen/c-types.sml

ifneq ($(MAKECMDGOALS),clean)
-include gen/gen-types.d
endif

gen/gen-types$(EXE): util.o

### basis-ffi.h  gen/basis-ffi.sml ###

basis-ffi.h: gen/basis-ffi.h
	$(CP) $< $@

define BASIS_FFI_TEMPLATE
ifeq ($(shell $(CAT) gen/gen-basis-ffi.sml gen/basis-ffi.def gen/$(1) | $(SHA1DGST)),$(shell $(CAT) gen/$(1).chk))
gen/$(1): gen/gen-basis-ffi.sml gen/basis-ffi.def
	touch gen/$(1)
else
gen/$(1): gen/gen-basis-ffi$(EXE) gen/basis-ffi.def
	$(EMULATE) ./gen/gen-basis-ffi$(EXE) $(1) < gen/basis-ffi.def > gen/$(1)
	$(CAT) gen/gen-basis-ffi.sml gen/basis-ffi.def gen/$(1) | $(SHA1DGST) > gen/$(1).chk
endif
endef

$(eval $(call BASIS_FFI_TEMPLATE,basis-ffi.h))
$(eval $(call BASIS_FFI_TEMPLATE,basis-ffi.sml))
$(eval $(call BASIS_FFI_TEMPLATE,gen-basis-ffi-consts.c))

gen/gen-basis-ffi$(EXE): gen/gen-basis-ffi.sml
	$(RUN_MLTON) -output gen/gen-basis-ffi$(EXE) gen/gen-basis-ffi.sml

### libgdtoa ###

GDTOA_CFILES := \
	dmisc.c     g_ddfmt.c   g_ffmt_p.c  gdtoa.c     misc.c      strtoIf.c   strtodI.c   strtopdd.c  strtord.c   sum.c \
	dtoa.c      g_ddfmt_p.c g_xLfmt.c   gethex.c    smisc.c     strtoIg.c   strtodg.c   strtopf.c   strtordd.c  ulp.c \
	g_Qfmt.c    g_dfmt.c    g_xLfmt_p.c gmisc.c     strtoIQ.c   strtoIx.c   strtof.c    strtopx.c   strtorf.c \
	g_Qfmt_p.c  g_dfmt_p.c  g_xfmt.c    hd_init.c   strtoId.c   strtoIxL.c  strtopQ.c   strtopxL.c  strtorx.c \
	g__fmt.c    g_ffmt.c    g_xfmt_p.c  hexnan.c    strtoIdd.c  strtod.c    strtopd.c   strtorQ.c   strtorxL.c
GDTOA_CFILES := $(patsubst %,gdtoa/%,$(GDTOA_CFILES))

GDTOA_OBJS := $(patsubst %.c,%.o,$(GDTOA_CFILES))

$(foreach F,$(GDTOA_CFILES), $(eval $(F)_XCFLAGS := -w -DINFNAN_CHECK))

ifneq ($(MAKECMDGOALS),clean)
-include $(patsubst %.o,%.d,$(GDTOA_OBJS))
endif

$(eval $(call A_TEMPLATE,gdtoa,GDTOA))

gdtoa/gdtoa.h $(GDTOACFILES): gdtoa/README
	@touch $@

gdtoa/README: gdtoa.tgz gdtoa.may_alias-unions.patch gdtoa.rename-public-fns.patch gdtoa.hide-private-fns.patch gdtoa.hide-public-fns.patch gdtoa.include-via-gdtoa.patch
	$(GZIP) -dc gdtoa.tgz | $(TAR) xf -
	$(PATCH) -s -d gdtoa -p1 <gdtoa.may_alias-unions.patch
	$(PATCH) -s -d gdtoa -p1 <gdtoa.rename-public-fns.patch
	$(PATCH) -s -d gdtoa -p1 <gdtoa.hide-private-fns.patch
	$(PATCH) -s -d gdtoa -p1 <gdtoa.hide-public-fns.patch
	$(PATCH) -s -d gdtoa -p1 <gdtoa.include-via-gdtoa.patch
	@touch $@

gdtoa/arith.h: gdtoa/arithchk$(EXE)
	$(EMULATE) ./gdtoa/arithchk$(EXE) > gdtoa/arith.h

gdtoa/arithchk.c: gdtoa/README
	@touch $@

gdtoa/arithchk.c_XCFLAGS := -w -O1

ifneq ($(MAKECMDGOALS),clean)
-include gdtoa/arithchk.d
endif

gdtoa/gd_qnan.h: gdtoa/qnan$(EXE)
	$(EMULATE) ./gdtoa/qnan$(EXE) > gdtoa/gd_qnan.h

gdtoa/qnan.c: gdtoa/README
	@touch $@

gdtoa/qnan.c_XCFLAGS := -w -O1

ifneq ($(MAKECMDGOALS),clean)
-include gdtoa/qnan.d
endif

### libmlton ###

BASIS_CFILES := $(shell $(FIND) basis -type f -name '*.c')

MLTON_OBJS := gc.o platform.o platform/$(TARGET_OS).o util.o
MLTON_OBJS += $(patsubst %.c,%.o,$(BASIS_CFILES))

gc.c_XCFLAGS := -Wno-address-of-packed-member

ifneq ($(MAKECMDGOALS),clean)
-include $(patsubst %.o,%.d,$(MLTON_OBJS))
endif

$(eval $(call A_TEMPLATE,mlton,MLTON))

### gen/constants ###

gen/constants: gen/gen-constants$(EXE)
	$(EMULATE) ./gen/gen-constants > gen/constants

ifneq ($(MAKECMDGOALS),clean)
-include gen/gen-constants.d
endif

gen/gen-constants$(EXE): libmlton.a

### bootstrap ###

ifeq (true,$(shell if [ -d bootstrap ]; then echo true; else echo false; fi))
BOOTSTRAP_CFILES := $(shell $(FIND) bootstrap -type f -name '*.c')

BOOTSTRAP_OBJS := $(patsubst %.c,%.o,$(BOOTSTRAP_CFILES))

bootstrap/$(MLTON_OUTPUT)$(EXE): $(BOOTSTRAP_OBJS) libmlton.a libgdtoa.a
	$(CC) $(call MK_FLAGS,-,LD) -L. -o $@ $(BOOTSTRAP_OBJS) -lmlton -lgdtoa -lgmp -lm

$(BOOTSTRAP_OBJS): bootstrap/%.o: bootstrap/%.c
	$(CC) $(call MK_FLAGS,-,C) -O1 -fno-strict-aliasing -foptimize-sibling-calls -w -I$(ROOT)/include -w -c -o $@ $<
endif

######

SHOW_VARS += TARGET TARGET_ARCH TARGET_OS
SHOW_VARS += WITH_OPT_RUNTIME WITH_DBG_RUNTIME WITH_DPI_RUNTIME WITH_NPI_RUNTIME WITH_PIC_RUNTIME WITH_PIE_RUNTIME
SHOW_VARS += XCCFLAGS XMFLAGS XCPPFLAGS XCFLAGS OPTXCFLAGS DBGXCFLAGS DPIXCFLAGS NPIXCFLAGS PICXCFLAGS PIEXCFLAGS XLDFLAGS
SHOW_VARS += HAVE_NPI WITH_DEFAULT_NPI HAVE_PIE WITH_DEFAULT_PIE HAVE_PIC WITH_DEFAULT_PIC
SHOW_VARS += LIBS

$(eval $(MK_COMMON_GOALS))

=== benchmark/tests/Makefile ===
## Copyright (C) 2022 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ../..
include $(ROOT)/Makefile.config

######################################################################

all:

CLEAN_EXTS := c s S
CLEAN_EXES := true
$(eval $(MK_COMMON_GOALS))

=== debian/changelog ===
mlton (20241230+git20251029+dfsg-1) unstable; urgency=medium

  * New upstream release fixes many build issues (DFSG-repacked upstream
    commit 61baac7108fbd91413f0537b7a42d9a1023455f4) (Closes: #1103850)
    + Now successfully rebuilds itself on hppa and i386 (Closes: #1003240)
    + Fix FTBFS on ppc64el (Closes: #1007016)
    + Fix segfault in tests (Closes: #917644)
    + Drop 06_local_docs.diff, no longer needed
  * Debian GNU/kFreeBSD has been terminated. Drop 03_kfreebsd.diff and
    corresponding binary packages
  * Improvements to README.source:
    + Update instructions for repacking DFSG-clean source tarball
    + Update (re)bootstrapping instructions for new architectures
  * Simplify bootstrapping on new architectures with schroot,
    09_schroot_bootstrap.diff
  * Upstream now uses asciidoctor instead of asciidoc. Update
    Build-Depends-Indep accordingly.
  * Upgrade watch file to version 5
  * Bump standards version to 4.7.2

 -- Ryan Kavanagh <rak@debian.org>  Mon, 03 Nov 2025 08:38:10 -0500

=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libgmp-dev,
Build-Depends-Arch:
 dh-exec,
 mlton-compiler,
 mlton-tools,
Build-Depends-Indep:
 asciidoctor,
 graphicsmagick,
 python3-pygments,
Homepage: http://mlton.org/
Standards-Version: 4.7.2
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler for Standard ML.
 MLton generates standalone executables with excellent runtime
 performance, is SML 97 compliant, and has a complete basis
 library. MLton has source-level profiling, a fast C FFI, an
 interface to the GNU multiprecision library, and lots of useful
 libraries.
Vcs-Browser: https://salsa.debian.org/debian/mlton
Vcs-Git: https://salsa.debian.org/debian/mlton.git -b debian/unstable
Rules-Requires-Root: no

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends:
 mlton-compiler (<< ${source:Version}.1~),
 mlton-compiler (>= ${source:Version}),
 mlton-tools (<< ${source:Version}.1~),
 mlton-tools (>= ${source:Version}),
 ${misc:Depends},
Recommends:
 mlton-doc,
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - basis library
 ${source:Extended-Description}
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 arm64 armel armhf hppa i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 gcc,
 libc6-dev,
 libgmp-dev,
 mlton-basis (= ${binary:Version}),
 mlton-runtime-native (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - compiler
 ${source:Extended-Description}
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 arm64 armel armhf hppa i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - tools
 ${source:Extended-Description}
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 arm64 armel armhf hppa i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Depends:
 mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-aarch64-linux-gnu (= ${binary:Version}) [arm64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-mips64el-linux-gnuabi64 (= ${binary:Version}) [mips64el] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-powerpc64le-linux-gnu (= ${binary:Version}) [ppc64el] | mlton-runtime-s390x-linux-gnu (= ${binary:Version}) [s390x] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc],
 ${misc:Depends},
Description: ${source:Synopsis} - native runtime libraries
 ${source:Extended-Description}
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-aarch64-linux-gnu
Architecture: arm64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips64el-linux-gnuabi64
Architecture: mips64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips-linux-gnu
Architecture: mips
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mipsel-linux-gnu
Architecture: mipsel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc-linux-gnu
Architecture: powerpc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc64le-linux-gnu
Architecture: ppc64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-riscv64-linux-gnu
Architecture: riscv64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-s390x-linux-gnu
Architecture: s390x
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-sparc-linux-gnu
Architecture: sparc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

MLTON_COMPILE_ARGS=$(patsubst %,-cc-opt '%',$(CFLAGS)) \
		   $(patsubst %,-as-opt '%',$(ASFLAGS)) \
		   $(patsubst %,-link-opt '%',$(LDFLAGS))

MLTON_COMPILE_ARGS=-cc-opt '$(CFLAGS)' -link-opt '$(LDFLAGS)' -as-opt '$(ASFLAGS)'
COMMON_OPTS=CC="$(CC)" \
	    DESTDIR="$(CURDIR)/debian/tmp" \
	    MLTON_VERSION=$(DEB_VERSION) \
	    PREFIX=/usr \
	    CFLAGS="$(CFLAGS)" \
	    CPPFLAGS="$(CPPFLAGS)" \
	    LDFLAGS="$(LDFLAGS)" \
	    MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS)"

%:
	dh $@

override_dh_auto_build-arch:
	$(MAKE) $(COMMON_OPTS)

override_dh_auto_build-indep:
	$(MAKE) $(COMMON_OPTS) docs

override_dh_auto_install-arch:
	$(MAKE) $(COMMON_OPTS) install-no-strip

override_dh_auto_install-indep:
	$(MAKE) $(COMMON_OPTS) install-docs

override_dh_compress:
	dh_compress -Xmlton/guide -X.sml

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_missing-indep:
	# The files under usr/lib/mlton/targets/self get installed into
	# the mlton-runtime-* packages, which are not arch-indep.
	# Exclude / ignore them when building with only -A.
	dh_missing -Xusr/lib/mlton/targets/self

# We do not need to test documentation
# and the call to $(MAKE) check fails because
# the binary build/bin/mlton only exists if
# we have called build-arch
override_dh_auto_test-indep:

override_dh_auto_test-arch:
	$(MAKE) $(COMMON_OPTS) check
	$(MAKE) $(COMMON_OPTS) basis-check
	$(MAKE) $(COMMON_OPTS) libraries-check

=== debian/watch ===
Version: 5
Template: GitHub
Owner: MLton
Project: mlton
Uversion-Mangle: s/-release$//
Dversion-Mangle: auto
